-----------------------------------------------------------------------------------------------
-- Client Lua Script for WildStarCensus
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- WildStarCensus Variables
-----------------------------------------------------------------------------------------------
-- Function variables
local WildStarCensus = {} 
local General = {}
local Lotto = {}
local Hash = {}

local tCensusData = {}
local tCensusDataFiltered = {}
local tMessages = {}
local tSettings = {}
local tTransfer = {}
local tIgnoreList = {}
				
local tFilter = {
				["Race"] = "",
				["Gender"] = "",
				["Class"] = "",
				["Path"] = "",
				["Level"] = ""}
local tCharacterFilter = {
        ["Name"] = "",
        ["Race"] = "",
        ["Class"] = "",
        ["Path"] = "",
        ["Level"] = ""}
local tReport = {
				["Bar_Race_Human"] = 0,
				["Bar_Race_Aurin"] = 0,
				["Bar_Race_Granok"] = 0,
				["Bar_Race_Mordesh"] = 0,
        ["Bar_Race_Cassian"] = 0,
				["Bar_Race_Draken"] = 0,
				["Bar_Race_Chua"] = 0,
				["Bar_Race_Mechari"] = 0,
				["Bar_Gender_Male"] = 0,
				["Bar_Gender_Female"] = 0,
				["Bar_Class_Warrior"] = 0,
				["Bar_Class_Engineer"] = 0,
				["Bar_Class_Esper"] = 0,
				["Bar_Class_Medic"] = 0,
				["Bar_Class_Stalker"] = 0,
				["Bar_Class_Spellslinger"] = 0,
				["Bar_Path_Soldier"] = 0,
				["Bar_Path_Settler"] = 0,
				["Bar_Path_Scientist"] = 0,
				["Bar_Path_Explorer"] = 0,
				["Bar_Level_1"] = 0, ["Bar_Level_2"] = 0, ["Bar_Level_3"] = 0, ["Bar_Level_4"] = 0, ["Bar_Level_5"] = 0, ["Bar_Level_6"] = 0, ["Bar_Level_7"] = 0, ["Bar_Level_8"] = 0, ["Bar_Level_9"] = 0, ["Bar_Level_10"] = 0,
				["Bar_Level_11"] = 0, ["Bar_Level_12"] = 0, ["Bar_Level_13"] = 0, ["Bar_Level_14"] = 0, ["Bar_Level_15"] = 0, ["Bar_Level_16"] = 0, ["Bar_Level_17"] = 0, ["Bar_Level_18"] = 0, ["Bar_Level_19"] = 0, ["Bar_Level_20"] = 0,
				["Bar_Level_21"] = 0, ["Bar_Level_22"] = 0, ["Bar_Level_23"] = 0, ["Bar_Level_24"] = 0, ["Bar_Level_25"] = 0, ["Bar_Level_26"] = 0, ["Bar_Level_27"] = 0, ["Bar_Level_28"] = 0, ["Bar_Level_29"] = 0, ["Bar_Level_30"] = 0,
				["Bar_Level_31"] = 0, ["Bar_Level_32"] = 0, ["Bar_Level_33"] = 0, ["Bar_Level_34"] = 0, ["Bar_Level_35"] = 0, ["Bar_Level_36"] = 0, ["Bar_Level_37"] = 0, ["Bar_Level_38"] = 0, ["Bar_Level_39"] = 0, ["Bar_Level_40"] = 0,
				["Bar_Level_41"] = 0, ["Bar_Level_42"] = 0, ["Bar_Level_43"] = 0, ["Bar_Level_44"] = 0, ["Bar_Level_45"] = 0, ["Bar_Level_46"] = 0, ["Bar_Level_47"] = 0, ["Bar_Level_48"] = 0, ["Bar_Level_49"] = 0, ["Bar_Level_50"] = 0}

local strFaction = ""
local strLanguage = ""
local tLocationCollect = {}

-----------------------------------------------------------------------------------------------
-- WildStarCensus Constants
-----------------------------------------------------------------------------------------------
local tColumns = {
				[0] = "Faction",
				[1] = "Level",
				[2] = "Race",
				[3] = "Gender",
				[4] = "Class",
				[5] = "Path",
				[6] = "Location",
				[7] = "Last Seen" }
  
local tRace = {
  [GameLib.CodeEnumRace.Human] = "Hu",
  [GameLib.CodeEnumRace.Aurin] = "Au",
  [GameLib.CodeEnumRace.Granok] = "Gr",
  [GameLib.CodeEnumRace.Mordesh] = "Mo",
  [GameLib.CodeEnumRace.Draken] = "Dr",
  [GameLib.CodeEnumRace.Chua] = "Ch",
  [GameLib.CodeEnumRace.Mechari] = "Mc"}

local tClass = {
  [GameLib.CodeEnumClass.Warrior] = "Wa",
  [GameLib.CodeEnumClass.Engineer] = "En",
  [GameLib.CodeEnumClass.Esper] = "Es",
  [GameLib.CodeEnumClass.Medic] = "Me",
  [GameLib.CodeEnumClass.Stalker] = "St",
  [GameLib.CodeEnumClass.Spellslinger] = "Sp"}

local tPath = {
  [PlayerPathLib.PlayerPathType_Soldier] 		= "So",
	[PlayerPathLib.PlayerPathType_Settler] 		= "Se",
	[PlayerPathLib.PlayerPathType_Scientist] 	= "Sc",
	[PlayerPathLib.PlayerPathType_Explorer] 	= "Ex"}

local tMatchBars = {
				["Hu"] = "Bar_Race_Human",
				["Au"] = "Bar_Race_Aurin",
				["Gr"] = "Bar_Race_Granok",
				["Mo"] = "Bar_Race_Mordesh",
        ["Ca"] = "Bar_Race_Cassian",
        ["Dr"] = "Bar_Race_Draken",
        ["Ch"] = "Bar_Race_Chua",
        ["Mc"] = "Bar_Race_Mechari",
				["m"]  = "Bar_Gender_Male",
				["f"]  = "Bar_Gender_Female",
				["Wa"] = "Bar_Class_Warrior",
				["En"] = "Bar_Class_Engineer",
				["Es"] = "Bar_Class_Esper",
				["Me"] = "Bar_Class_Medic",
				["St"] = "Bar_Class_Stalker",
				["Sp"] = "Bar_Class_Spellslinger",
				["So"] = "Bar_Path_Soldier",
				["Se"] = "Bar_Path_Settler",
				["Sc"] = "Bar_Path_Scientist",
				["Ex"] = "Bar_Path_Explorer"}
      
local tDataToName = {
        ["Hu"] = "Human",
				["Au"] = "Aurin",
				["Gr"] = "Granok",
				["Mo"] = "Mordesh",
        ["Ca"] = "Cassian",
        ["Dr"] = "Draken",
        ["Ch"] = "Chua",
        ["Mc"] = "Mechari",
				["Wa"] = "Warrior",
				["En"] = "Engineer",
				["Es"] = "Esper",
				["Me"] = "Medic",
				["St"] = "Stalker",
				["Sp"] = "Spellslinger",
				["So"] = "Soldier",
				["Se"] = "Settler",
				["Sc"] = "Scientist",
				["Ex"] = "Explorer"}
				
local tFriendshipResult = {
	[FriendshipLib.FriendshipResult_PlayerNotFound] = Apollo.GetString("Friends_PlayerNotFound"),
	[FriendshipLib.FriendshipResult_RealmNotFound] = Apollo.GetString("Friends_RealmNotFound"),
	[FriendshipLib.FriendshipResult_RequestDenied] = Apollo.GetString("Friends_RequestDenied"),
	[FriendshipLib.FriendshipResult_PlayerAlreadyFriend] = Apollo.GetString("Friends_AlreadyFriendsMsg"),
	[FriendshipLib.FriendshipResult_PlayerOffline] = Apollo.GetString("Friends_PlayerOffline"),
	[FriendshipLib.FriendshipResult_FriendshipNotFound] = Apollo.GetString("Friends_NotFound"),
	[FriendshipLib.FriendshipResult_InvalidType] = Apollo.GetString("Friends_InvalidType"),
	[FriendshipLib.FriendshipResult_RequestNotFound] = Apollo.GetString("Friends_RequestNotFound"),
	[FriendshipLib.FriendshipResult_RequestTimedOut] = Apollo.GetString("Friends_RequestTimeOut"),
	[FriendshipLib.FriendshipResult_Busy] = Apollo.GetString("Friends_BusyMsg"),
	[FriendshipLib.FriendshipResult_InvalidNote] = Apollo.GetString("Friends_InvalidNote"),
	[FriendshipLib.FriendshipResult_MaxFriends] = Apollo.GetString("Friends_MaxFriends"),
	[FriendshipLib.FriendshipResult_MaxRivals] = Apollo.GetString("Friends_MaxRivals"),
	[FriendshipLib.FriendshipResult_MaxIgnored] = Apollo.GetString("Friends_MaxIgnored"),
	[FriendshipLib.FriendshipResult_UnableToProcess] = Apollo.GetString("Friends_CannotProcess"),
	[FriendshipLib.FriendshipResult_PlayerNotFriend] = Apollo.GetString("Friends_PlayerNotFound"),
	[FriendshipLib.FriendshipResult_PlayerConsideringOtherFriend] = Apollo.GetString("Friends_MultipleRequests"),
	[FriendshipLib.FriendshipResult_RequestSent] = Apollo.GetString("Friends_RequestSent"),
	[FriendshipLib.FriendshipResult_PlayerAlreadyRival] = Apollo.GetString("Friends_AlreadyRival"),
	[FriendshipLib.FriendshipResult_PlayerAlreadyNeighbor] = Apollo.GetString("Friends_AlreadyNeighbor"),
	[FriendshipLib.FriendshipResult_PlayerAlreadyIgnored] = Apollo.GetString("Friends_AlreadyIgnored"),
	[FriendshipLib.FriendshipResult_PlayerOnIgnored] = Apollo.GetString("Friends_PlayerIgnored"),
	[FriendshipLib.FriendshipResult_PlayerNotRival] = Apollo.GetString("Friends_NotRival"),
	[FriendshipLib.FriendshipResult_PlayerNotIgnored] = Apollo.GetString("Friends_NotIgnored"),
	[FriendshipLib.FriendshipResult_PlayerNotNeighbor] = Apollo.GetString("Friends_NotNeighbor"),
	[FriendshipLib.FriendshipResult_PlayerNotOfThisRealm] = Apollo.GetString("Friends_NotOnRealm"),
	[FriendshipLib.FriendshipResult_FriendsBlocked] = Apollo.GetString("Friends_BlockingRequests"),
	[FriendshipLib.FriendshipResult_CannotInviteSelf] = Apollo.GetString("Friends_CannotInviteSelf"),
	[FriendshipLib.FriendshipResult_ThrottledRequest] = Apollo.GetString("Friends_ThrottledRequest"),
	[FriendshipLib.FriendshipResult_ContainsProfanity] = Apollo.GetString("Friends_ContainsProfanity"),
	[FriendshipLib.FriendshipResult_InvalidPublicNote] = Apollo.GetString("Friends_InvalidPublicNote"),
	[FriendshipLib.FriendshipResult_InvalidPublicDisplayName] = Apollo.GetString("Friends_InvalidPublicDisplayName"),
	[FriendshipLib.FriendshipResult_BlockedForStrangers] = Apollo.GetString("Friends_BlockedForStrangers"),
	[FriendshipLib.FriendshipResult_InvalidEmail] = Apollo.GetString("Friends_InvalidPublicDisplayName"),
	[FriendshipLib.FriendshipResult_InvalidAutoResponse] = Apollo.GetString("Friends_InvalidAutoResponse"),
	[FriendshipLib.FriendshipResult_NameUnavailable] = Apollo.GetString("Friends_NameUnavailable"),
}
local tLocations = {}

-----------------------------------------------------------------------------------------------
-- WildStarCensus Initialization
-----------------------------------------------------------------------------------------------
function WildStarCensus:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
	
    return o
end

function WildStarCensus:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
  Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 
-----------------------------------------------------------------------------------------------
-- WildStarCensus OnLoad / OnDocLoaded
-----------------------------------------------------------------------------------------------
function WildStarCensus:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("WildStarCensus.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
  
  -- join exchange channel
  self.chanCensus = ICCommLib.JoinChannel("CensusVonHvin", "OnCensusMessage", self)
end

function WildStarCensus:OnDocLoaded()
	
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
    -- Set Main Windows
	   self.wndMain = Apollo.LoadForm(self.xmlDoc, "WildStarCensusForm", nil, self)
     self.wndMain:Show(false, true)
     self.wndPurgeConfirmation = Apollo.LoadForm(self.xmlDoc, "ConfirmPurgeDataForm", self.wndMain, self)
     self.wndPurgeConfirmation:Show(false, true)
     self.wndCharacterOptions = Apollo.LoadForm(self.xmlDoc, "CharacterOptionsForm", self.wndMain, self)
     self.wndCharacterOptions:Show(false, true)
     self.wndAddonInfo = Apollo.LoadForm(self.xmlDoc, "AddonInfoForm", self.wndMain, self)
     self.wndAddonInfo:Show(false, true)
     
     
     if self.wndMain == nil or self.wndPurgeConfirmation == nil then
       Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
    
    -- Set other Windows
		self.wndImportList = self.wndMain:FindChild("CensusImportList")
    self.wndIgnoreList = self.wndMain:FindChild("CensusIgnoreList")
    self.wndIconE = self.wndMain:FindChild("Icon_Exile")
    self.wndIconD = self.wndMain:FindChild("Icon_Dominion")
    self.wndRaceE = self.wndMain:FindChild("RaceWindow_E")
    self.wndRaceD = self.wndMain:FindChild("RaceWindow_D")
    self.wndGender = self.wndMain:FindChild("GenderWindow")
    self.wndClass = self.wndMain:FindChild("ClassWindow")
    self.wndPath = self.wndMain:FindChild("PathWindow")
    self.wndSettingsForm = self.wndMain:FindChild("CensusSettingsForm")
    self.wndReportForm = self.wndMain:FindChild("CensusReportForm")
    self.wndCharactersForm = self.wndMain:FindChild("CensusCharacterForm")
    self.wndCharactersContent = self.wndMain:FindChild("Characters_Content")
    self.wndSortButtonMarked = self.wndMain:FindChild("Character_Sort_Marked")
    self.wndBtnStart = self.wndMain:FindChild("Start_Button")
    self.wndBtnStop = self.wndMain:FindChild("Stop_Button")
    self.wndBtnLock = self.wndMain:FindChild("Lock_Button")
    self.wndBtnUnlock = self.wndMain:FindChild("Unlock_Button")


		-- Register event handlers
		Apollo.RegisterSlashCommand("wscensus", "OnWildStarCensus", self)
    Apollo.RegisterEventHandler("WhoResponse", "OnCensusWho", self)
    Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
    Apollo.RegisterEventHandler("ToggleCensus", "OnToggleCensus", self)
    Apollo.RegisterEventHandler("FriendshipResult", "OnFriendshipResult", self)
    Apollo.RegisterEventHandler("EventGeneric_PopulateCharacterList", "OnPopulateCharacterList", self)
		
    tSettings["CensusRunning"] = tSettings["CensusRunning"] or false
    tSettings["CensusLocked"] = tSettings["CensusLocked"] or false
    
    -- Set Timers
    local nTimer = tSettings["CensusTimerSecs"] or 300
		self.CensusTimer = ApolloTimer.Create(nTimer, true, "OnCensusTimer", self)
    if nTimer == 0 then self.CensusTimer:Stop() end
    
    nTimer = tSettings["TransferTimerSecs"] or 600
		self.TransferTimer = ApolloTimer.Create(nTimer, true, "OnTransferTimer", self)
    
    self.StartTimer = ApolloTimer.Create(1, true, "OnStartTimer", self)
    self.ZoneTimer = ApolloTimer.Create(30, true, "OnZoneTimer", self)
	end
end

-----------------------------------------------------------------------------------------------
-- WildStarCensus Timer
-----------------------------------------------------------------------------------------------
function WildStarCensus:OnStartTimer()
  
  strLanguage = General:GetClientLanguage()
  self.StartTimer:Stop()
	if GameLib.GetPlayerUnit():GetFaction() == Unit.CodeEnumFaction.DominionPlayer then
		strFaction = "D"
    self.wndRaceChosen = Apollo.LoadForm(self.xmlDoc, "IconChosenForm", self.wndRaceD, self)
	else
		strFaction = "E"
    self.wndRaceChosen = Apollo.LoadForm(self.xmlDoc, "IconChosenForm", self.wndRaceE, self)
	end
  
  self.wndGenderChosen = Apollo.LoadForm(self.xmlDoc, "IconChosenForm", self.wndGender, self)
  self.wndClassChosen = Apollo.LoadForm(self.xmlDoc, "IconChosenForm", self.wndClass, self)
  self.wndPathChosen = Apollo.LoadForm(self.xmlDoc, "IconChosenForm", self.wndPath, self)
  self.wndRaceChosen:Show(false, true)
  self.wndGenderChosen:Show(false, true)
  self.wndClassChosen:Show(false, true)
  self.wndPathChosen:Show(false, true)
  
  self:OnDataTransfer()
  
  self.wndAddonInfo:FindChild("AddonInfo_Version"):SetText("v1.0 / 2014-07-20")
  self.wndAddonInfo:FindChild("AddonInfo_Author"):SetText("Thjodolf")
  self.wndAddonInfo:FindChild("AddonInfo_Thanks"):SetText("Rharaku & Sojiro84")
end

function WildStarCensus:OnCensusTimer()
	if tSettings["CensusRunning"] then
		ChatSystemLib.Command("/" .. Apollo.GetString("Command_Who"))
	end
end

function WildStarCensus:OnTransferTimer()
  self:OnDataTransfer()
end

-----------------------------------------------------------------------------------------------
-- WildStarCensus Slash-Command Function
-----------------------------------------------------------------------------------------------
function WildStarCensus:OnWildStarCensus(tMessage)
  
	self:OnPopulateImportList()
  self:OnPopulateIgnoreList()
  self.wndMain:FindChild("CensusTimerSettingDropDown"):SetText(tSettings["CensusTimerText"] or "")
  self.wndMain:FindChild("TransferTimerSettingDropDown"):SetText(tSettings["TransferTimerText"] or "")
	self.wndMain:FindChild("Realm_Info"):SetText(GameLib.GetRealmName())
	self:OnCensusReport()
  self:SetStartStopButtons()
	self.wndMain:Show(true, true) -- show the window
	
  if strLanguage == "deDE" then
    self.wndGender:Show(true,true)
  else
    self.wndGender:Show(false,true)
  end
  
	if strFaction == "D" then
    self.wndIconD:Show(true,true)
    self.wndIconE:Show(false,true)
    self.wndRaceD:Show(true,true)
    self.wndRaceE:Show(false,true)
	else
    self.wndIconE:Show(true,true)
    self.wndIconD:Show(false,true)
    self.wndRaceE:Show(true,true)
    self.wndRaceD:Show(false,true)
	end	
end

function WildStarCensus:OnTabChange( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
	if wndControl:GetName() == "Tab_Report" then
    self.wndReportForm:Show(true,true)
    self.wndSettingsForm:Show(false,true) 
    self.wndCharactersForm:Show(false,true)
    self.wndCharacterOptions:Show(false, true)
    self.wndCharacterOptions:SetData(nil)
	elseif wndControl:GetName() == "Tab_Characters" then
    Event_FireGenericEvent("EventGeneric_PopulateCharacterList")
    self.wndCharactersForm:Show(true,true)
    self.wndReportForm:Show(false,true)
    self.wndSettingsForm:Show(false,true) 
	elseif wndControl:GetName() == "Tab_Settings" then
    self.wndSettingsForm:Show(true,true)
    self.wndReportForm:Show(false,true)
    self.wndCharactersForm:Show(false,true)
    self.wndCharacterOptions:Show(false, true)
    self.wndCharacterOptions:SetData(nil)
	end	
end

function WildStarCensus:OnCancel()
	self.wndMain:Close()
  self.wndPurgeConfirmation:Close()
  self.wndAddonInfo:Close()
end

function WildStarCensus:OnAddonInfo( wndHandler, wndControl, eMouseButton )
  self.wndAddonInfo:Show(not self.wndAddonInfo:IsShown(), true)
  self.wndAddonInfo:ToFront()
end

function WildStarCensus:OnInterfaceMenuListHasLoaded()
  Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "WildStar Census", {"ToggleCensus", "", "CRB_ActionBarFrameSprites:sprResourceBar_Sprint_RunIconSilver"})
 
  --self:UpdateInterfaceMenuAlerts()
end

function WildStarCensus:OnToggleCensus()
  if self.wndMain:IsShown() then
    self:OnCancel()
  else
    self:OnWildStarCensus()
  end
end

-----------------------------------------------------------------------------------------------
-- WildStarCensus Collecting Data
-----------------------------------------------------------------------------------------------
function WildStarCensus:OnStartStop( wndHandler, wndControl, eMouseButton )
	if wndControl:GetName() == "Start_Button" then
		tSettings["CensusRunning"] = true
		ChatSystemLib.Command("/" .. Apollo.GetString("Command_Who"))
	elseif wndControl:GetName() == "Stop_Button" then
		tSettings["CensusRunning"] = false
  elseif wndControl:GetName() == "Lock_Button" then
    tSettings["CensusLocked"] = true
  elseif wndControl:GetName() == "Unlock_Button" then
    tSettings["CensusLocked"] = false
  else
  end
  
  self:SetStartStopButtons()
end

function WildStarCensus:SetStartStopButtons()
  self.wndBtnStart:Show(not tSettings["CensusRunning"], true)
  self.wndBtnStop:Show(tSettings["CensusRunning"], true)
  self.wndBtnLock:Show(not tSettings["CensusLocked"], true)
  self.wndBtnUnlock:Show(tSettings["CensusLocked"], true)
  self.wndBtnStop:Enable(not tSettings["CensusLocked"])
  self.wndBtnLock:Enable(tSettings["CensusRunning"])
end

function WildStarCensus:OnCensusWho(arResponse, eWhoResult)
	local tResult = {}
	local strKey = ""
	local strValue = ""
  local strGender = ""
	local nSize = 0
	
	if tCensusData ~= nil then
		tResult = tCensusData
	end
	local i = table.getn(tResult)
	if tSettings["CensusRunning"] then
		if eWhoResult == GameLib.CodeEnumWhoResult.OK or eWhoResult == GameLib.CodeEnumWhoResult.Partial then
			if arResponse == nil or #arResponse == 0 then
				return
			end

			for _, tWho in ipairs(arResponse) do
        if strLanguage == "deDE" and string.sub(tWho.strClass, -2) == "in" then
          strGender = "f"
				else
          strGender = "m"
				end
        
        tResult[tWho.strName] = {}
        tResult[tWho.strName][tColumns[0]] = strFaction
        tResult[tWho.strName][tColumns[1]] = tWho.nLevel
        tResult[tWho.strName][tColumns[2]] = tRace[tWho.eRaceId]
        tResult[tWho.strName][tColumns[3]] = strGender
        tResult[tWho.strName][tColumns[4]] = tClass[tWho.eClassId]
        tResult[tWho.strName][tColumns[5]] = tPath[tWho.ePlayerPathType]
        tResult[tWho.strName][tColumns[6]] = tWho.idWorldZone
        tResult[tWho.strName][tColumns[7]] = General:GetStrServerTime()
			end

      for k, v in pairs(tResult) do
        if v[tColumns[0]] == "D" and v[tColumns[2]] == "Hu" then 
           v[tColumns[2]] = "Ca"
        end
      end
      
			tCensusData = tResult
			self:OnCensusReport()
		elseif eWhoResult == GameLib.CodeEnumWhoResult.UnderCooldown then
		end
	end
end

function WildStarCensus:OnCensusReport()
	local tMaxValues = {
					["Race"] = 0,
					["Gender"] = 0,
					["Class"] = 0,
					["Path"] = 0,
					["Level"] = 0,
					["Total"] = 0}
	local bCharFits = false

	for k, _ in pairs(tReport) do
		tReport[k] = 0
	end
	
	if tCensusData ~= nil then
		for _, tbl in pairs(tCensusData) do
			bCharFits = tbl["Faction"] == strFaction
			for k, v in pairs(tFilter) do
				if v ~= "" and bCharFits then
          if k == "Level" then
            bCharFits = "Bar_Level_" .. tbl[k] == v
          else
            bCharFits = tMatchBars[tbl[k]] == v
          end
				end
			end
		
			if bCharFits then
				tReport[tMatchBars[tbl["Race"]]] = tReport[tMatchBars[tbl["Race"]]] + 1
				tReport[tMatchBars[tbl["Gender"]]] = tReport[tMatchBars[tbl["Gender"]]] + 1
				tReport[tMatchBars[tbl["Class"]]] = tReport[tMatchBars[tbl["Class"]]] + 1
				tReport[tMatchBars[tbl["Path"]]] = tReport[tMatchBars[tbl["Path"]]] + 1
				tReport["Bar_Level_" .. tbl["Level"]] = tReport["Bar_Level_" .. tbl["Level"]] + 1
				tMaxValues["Total"] = tMaxValues["Total"] + 1
			end
		end
	end
	
	for k, v in pairs(tReport) do
		local strType = ""
		
		strType = string.match(k, "_%a+_")
		strType = string.gsub(strType,"_","")
		
		if v > tMaxValues[strType] then tMaxValues[strType] = v end
	end
	
	for k, v in pairs(tReport) do
		local nDivisor = 0
		local strTooltip = ""
		local strType = ""
		local tOffsets = {}
		
		strType = string.match(k, "_%a+_")
		strType = string.gsub(strType,"_","")
		
		if strType == "Level" then
			strTooltip = "Level " .. string.match(k, "%d+") .. ": " .. v .. " | " .. math.floor(v / tMaxValues["Total"] * 100 + 0.5) .. "%"
		else
			strTooltip = v .. " | " .. math.floor(v / tMaxValues["Total"] * 100 + 0.5) .. "%"
		end
		
		tOffsets = {self.wndMain:FindChild(k):GetAnchorOffsets()}
		tOffsets[2] = ((v / tMaxValues[strType]) * -120) - 8
		
		if tOffsets[2] >= -128 and tOffsets[2] <= -8 then
			self.wndMain:FindChild(k):SetTooltip(strTooltip)
			self.wndMain:FindChild(k):SetAnchorOffsets(tOffsets[1], tOffsets[2], tOffsets[3], tOffsets[4])
		end	
	end
	
	self.wndMain:FindChild("CharTotal_Info"):SetText(tMaxValues["Total"])
end

---------------------------------------------------------------------------------------------------
-- WildStarCensus Filter Data / Purge Data
---------------------------------------------------------------------------------------------------
function WildStarCensus:OnCensusFilter( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
	local i = 0
	local strFilter = ""
	local strFilterType = ""
  local wndChosen
  
  local cChosen = string.sub(wndControl:GetName(),6,6)

  if cChosen == "R" then
    wndChosen = self.wndRaceChosen
  elseif cChosen == "G" then
    wndChosen = self.wndGenderChosen
  elseif cChosen == "C" then
    wndChosen = self.wndClassChosen
  elseif cChosen == "P" then
    wndChosen = self.wndPathChosen
  else
  end
	
	-- Check FilterAttributes with clicked icon
	for str in string.gmatch(wndControl:GetName(), "[^_]+") do
		if i == 1 then
			strFilterType = str
			
		elseif i == 2 then
			-- If it's already filtered by chosen attribute, then erase filter, else change it to chosen attribute
			strFilter = "Bar_" .. strFilterType .. "_".. str
			if tFilter[strFilterType] == strFilter then
				tFilter[strFilterType] = ""
				self.wndMain:FindChild("Filter_" .. strFilterType):SetText("")
        if wndChosen ~= nil then
          wndChosen:Show(false, true)
        end
			else
				tFilter[strFilterType] = strFilter 
				self.wndMain:FindChild("Filter_" .. strFilterType):SetText(str)
        if wndChosen ~= nil then
          wndChosen:SetAnchorPoints(wndControl:GetAnchorPoints())
          wndChosen:SetAnchorOffsets(wndControl:GetAnchorOffsets())
          wndChosen:Show(true, true)
        end
			end
		end
		i = i + 1
	end
	
	-- update the CensusReport
	self:OnCensusReport()
end

function WildStarCensus:OnEraseFilter( wndHandler, wndControl, eMouseButton )
	for k, v in pairs(tFilter) do
    if k ~= "Faction" then
      self.wndMain:FindChild("Filter_" .. k):SetText("")
      tFilter[k] = ""
    end
	end
  
  self.wndRaceChosen:Show(false, true)
  self.wndGenderChosen:Show(false, true)
  self.wndClassChosen:Show(false, true)
  self.wndPathChosen:Show(false, true)
  
	-- update the CensusReport
	self:OnCensusReport()
end

function WildStarCensus:OnPurgeConfirm( wndHandler, wndControl, eMouseButton )
	self.wndPurgeConfirmation:Show(true, true)
	self.wndPurgeConfirmation:ToFront()
end

function WildStarCensus:OnPurgeData( wndHandler, wndControl, eMouseButton )
	if wndControl:GetName() == "Confirm_Button" then
    for k, v in pairs(tCensusData) do
      if tCensusData[k]["Faction"] == strFaction then tCensusData[k] = nil end
    end
		self:OnCensusReport()
	end
	self.wndPurgeConfirmation:Show(false, true)
end

function WildStarCensus:OnEraseCharacterFilter( wndHandler, wndControl, eMouseButton )
  for k, v in pairs(tCharacterFilter) do
    tCharacterFilter[k] = ""
  end
  self.wndMain:FindChild("FilterInput"):SetText("")
  Event_FireGenericEvent("EventGeneric_PopulateCharacterList")
end

function WildStarCensus:OnDeleteCharacterConfirm( wndHandler, wndControl, eMouseButton )
end

---------------------------------------------------------------------------------------------------
-- WildStarCensus Transfer-Functions
---------------------------------------------------------------------------------------------------
function WildStarCensus:OnDataTransfer()
	local strTransfer = ""
	local strTransferPart = ""
	local strServerTime = General:GetStrServerTime()
  local strValue = ""
	local i = 0
	local iCount = 1
	local iLotto = 1
	local nTimeDiff = 0
	local maxEntries = 0
	local maxTransfer = 200
	local maxTimeDiff = 43200
  local maxPerMessage = 500
	local TransferCount = 0
	local tLotto = {}
  local tDataTransfer = {}
	
  if next(tCensusData) == nil then return end
  
  -- empty global table tTransfer
  tTransfer = {}
  
	for k, v in pairs(tCensusData) do
		if v["Faction"] == strFaction and General:GetDifferenceTime(v["Last Seen"], strServerTime) <= maxTimeDiff then maxEntries = maxEntries + 1 end
	end
  
	tLotto = Lotto:GetLottoTable(maxEntries, maxTransfer)
	
	-- CensusData is put into a string with "/" as delimiter between columns and "|" as delimiter between entries/rows
	for k, v in pairs(tCensusData) do
		-- Difference between entry-time and current servertime in minutes
		nTimeDiff = General:GetDifferenceTime(v["Last Seen"], strServerTime)
		-- If Entry is older than 30 days (= 43.200 mins) then skip entry
		if v["Faction"] == strFaction and nTimeDiff <= maxTimeDiff then
			if maxEntries <= maxTransfer or tLotto[iLotto] == iCount then
				strTransferPart = k .. "/"
				for i = 0,  table.getn(tColumns)-1 do
          strValue = v[tColumns[i]] or ""
          strTransferPart = strTransferPart .. strValue .. "/"
				end
				strTransferPart = strTransferPart .. nTimeDiff  .. "|"
				
				iLotto = iLotto + 1
			end
			iCount = iCount + 1
		end

		if string.find(strTransferPart, "[%P\128-\165]+/%a/%d%d?/%a%a/%a/%a%a/%a%a/%d%d?%d?%d?/%d+|") ~= nil then
			strTransfer = strTransfer .. strTransferPart
			TransferCount = TransferCount + 1
			strTransferPart = ""
		end
		
		if iLotto > maxTransfer then break end
	end

  if TransferCount == 0 then return end
  
	-- Cutting the string in parts of x characters and saving each line into a table
	-- with adding an index + ":" in front of the text and putting an End of message <EOM> after the last entry
	for i = 0, math.floor(string.len(strTransfer)/maxPerMessage) do
		tDataTransfer[i] = string.sub(strTransfer, i*maxPerMessage+1, (i+1)*maxPerMessage)
	end
	-- Adding the EOM together with the Servertime
	tDataTransfer[table.getn(tDataTransfer) + 1] = strServerTime .. "<EOM>" .. Hash:elfHash(General:ShrinkString(strTransfer, 32, 3)) .. TransferCount
	
  self.chanCensus:SendMessage(tDataTransfer)
end

function WildStarCensus:OnCensusMessage(channel, tMsg, strSender)
	local strMessage = ""
  local countEntries = 0
	local pos = 0
	local i = 0
  
  for i = 0, table.getn(tMsg) do
    if tMsg[i] == nil then
      break
    end
    
    if string.find(tMsg[i], "<EOM>") == nil then
      strMessage = strMessage .. tMsg[i]
    else
      _, countEntries = string.gsub(strMessage, "[%P\128-\165]+/%a/%d%d?/%a%a/%a/%a%a/%a%a/%d%d?%d?%d?/%d+|", "")
      
      -- If Hash is correct and number of entries is correct then save in the Message-Table with Server-Time
      pos = string.find(tMsg[i], ">")
      if Hash:elfHash(General:ShrinkString(strMessage, 32, 3)) == string.sub(tMsg[i], pos+1, pos+8) and countEntries == tonumber(string.sub(tMsg[i], pos+9)) then
        pos = string.find(tMsg[i], "<")
        if tMessages[strSender] == nil then tMessages[strSender] = {} end
        tMessages[strSender][string.sub(tMsg[i], 1, pos-1)] = strMessage
        self:OnPopulateImportList()
      end
    end
  end
end

function WildStarCensus:OnImportData( wndHandler, wndControl, eMouseButton )
  if string.find(wndControl:GetName(), "Delete") == nil then
    for kn, t in pairs(tMessages) do
      for kt, v in pairs(t) do
        if tIgnoreList[kn] == nil then
          self:OnImportEntry(kt,v)
        end
        tMessages[kn][kt] = nil
      end
      tMessages[kn] = nil
    end
  else
    tMessages = {}
  end
  self:OnPopulateImportList()
end

function WildStarCensus:OnImportEntry(strServerTime, strMessage)
local pattern = "([%P\128-\165]+)/(%a)/(%d%d?)/(%a%a)/(%a)/(%a%a)/(%a%a)/(%d%d?%d?%d?)/(%d+)"
tEntryData = {}

  for str in string.gmatch(strMessage, "[^|]+") do
    bImport = true
    name, tEntryData[0], tEntryData[1], tEntryData[2], tEntryData[3], tEntryData[4], tEntryData[5], tEntryData[6], tEntryData[7] = string.match(str, pattern)

    tEntryData[7] = General:GetTimeStringToNumber(strServerTime) - (tEntryData[7] * 60)
    if tCensusData[name] ~= nil then
      if General:GetTimeStringToNumber(tCensusData[name]["Last Seen"]) >= tEntryData[7] then
      end
    else
      tCensusData[name] = {}
    end
    
    if bImport then
      tEntryData[7] = General:GetTimeNumberToString(tEntryData[7])
      for k, v in pairs(tEntryData) do
        tCensusData[name][tColumns[k]] = v
      end
    end
  end
  self:OnCensusReport()
end

-----------------------------------------------------------------------------------------------
-- WildStarCensus Import-/Ignore-List
-----------------------------------------------------------------------------------------------
function WildStarCensus:OnSetIgnoreList( wndHandler, wndControl, eMouseButton )
  
  if wndControl:GetName() == "ButtonToIgnore" then
    local posSel = self.wndImportList:GetCurrentRow()
    if posSel ~= nil then
      local ImpSel = self.wndImportList:GetCellText(posSel)
      tIgnoreList[ImpSel] = General:GetStrServerTime()
    end    
  else
    local posSel = self.wndIgnoreList:GetCurrentRow()
    if posSel ~= nil then
      local ImpSel = self.wndIgnoreList:GetCellText(posSel)
      tIgnoreList[ImpSel] = nil
    end
  end
  self:OnPopulateImportList()
  self:OnPopulateIgnoreList()
end

function WildStarCensus:OnPopulateImportList()
  local LastImport
  local nTime
  
	-- Detele all entries
	self.wndImportList:DeleteAll()
	
	for ks, v in pairs(tMessages) do
    if tIgnoreList[ks] == nil then
      LastImport = ""
      nTime = 0
      for kt, _ in pairs(v) do
        if nTime < General:GetTimeStringToNumber(kt) then 
          nTime = General:GetTimeStringToNumber(kt)
          LastImport = kt
        end
      end
    local newRow = self.wndImportList:AddRow("")
    self.wndImportList:SetCellText(newRow, 1, ks)
    self.wndImportList:SetCellText(newRow, 2, LastImport)
    end
	end
end

function WildStarCensus:OnPopulateIgnoreList()
	-- Detele all entries
	self.wndIgnoreList:DeleteAll()
  
  for k, _ in pairs(tIgnoreList) do
    local newRow = self.wndIgnoreList:AddRow("")
    self.wndIgnoreList:SetCellText(newRow, 1, k)
  end
end


-----------------------------------------------------------------------------------------------
-- WildStarCensus Characters
-----------------------------------------------------------------------------------------------
function WildStarCensus:OnPopulateCharacterList()  
  local wndNewListItem
  local nTimeDiff = 0
  local nValue = 0
  local strTimeDiff = ""
  local nCursor = 0
  local tResult = {}
  
  self.wndCharactersContent:DestroyChildren()
  tResult = self:OnCreateFilteredList()
  
  for k, t in pairs(tCensusDataFiltered) do
    if t[tColumns[0]] == strFaction then
      wndNewListItem = Apollo.LoadForm(self.xmlDoc, "CharacterItemForm", self.wndCharactersContent, self)
      wndNewListItem:SetName(k)
      wndNewListItem:FindChild("Name"):SetText(k)
      wndNewListItem:FindChild(tColumns[1]):SetText(t[tColumns[1]])
      local strRaceIcon = tDataToName[t[tColumns[2]]]
      local strClassIcon = tDataToName[t[tColumns[4]]]
      local strPathIcon = tDataToName[t[tColumns[5]]]
      if strRaceIcon == "Cassian" then strRaceIcon = "Human" end
      if strPathIcon == "Settler" then strPathIcon = "Colonist" end
      --Icon_Windows_UI_CRB_
      wndNewListItem:FindChild(tColumns[2]):SetSprite("sprCC_Race" .. strRaceIcon)
      wndNewListItem:FindChild(tColumns[2]):SetTooltip(tDataToName[t[tColumns[2]]])
      wndNewListItem:FindChild(tColumns[2]):SetData(t[tColumns[2]])
      wndNewListItem:FindChild(tColumns[4]):SetSprite("Icon_Windows_UI_CRB_" .. strClassIcon)
      wndNewListItem:FindChild(tColumns[4]):SetTooltip(tDataToName[t[tColumns[4]]])
      wndNewListItem:FindChild(tColumns[4]):SetData(t[tColumns[4]])
      wndNewListItem:FindChild(tColumns[5]):SetSprite("Icon_Windows_UI_CRB_" .. strPathIcon)
      wndNewListItem:FindChild(tColumns[5]):SetTooltip(tDataToName[t[tColumns[5]]])
      wndNewListItem:FindChild(tColumns[5]):SetData(t[tColumns[5]])
      nTimeDiff = math.floor((General:GetTimeStringToNumber(General:GetStrServerTime()) - General:GetTimeStringToNumber(t[tColumns[7]])) / 60 / 60)
      wndNewListItem:FindChild(tColumns[7]):SetData(nTimeDiff)
      
      if nTimeDiff > 23 then
        nValue = math.floor(nTimeDiff / 24)
        strTimeDiff = nValue .. " day"
      else
        nValue = nTimeDiff
        strTimeDiff = nValue .. " hour"
      end
      
      if nValue > 1 or nValue == 0 then strTimeDiff = strTimeDiff .. "s" end
      strTimeDiff = strTimeDiff .. " ago"
      
      wndNewListItem:FindChild(tColumns[7]):SetText(strTimeDiff)
      --wndNewListItem:FindChild(tColumns[6]):SetText(t[tColumns[6]])
      wndNewListItem:SetAnchorOffsets(0, nCursor, 0, nCursor + 40)
      wndNewListItem:Show(true, true)
      nCursor = nCursor + 40
    end
  end
  
  self.wndCharactersContent:SetVScrollPos(0)
  self:SortCharacterList()
  self.wndMain:FindChild("CharacterCount"):SetText("Showing " .. tResult["nCount"] .. " of ".. tResult["nTotalChars"] .. " characters")
  --self:OnFilterCharacterList(self.wndMain:FindChild("FilterInput"):GetText())
end

function WildStarCensus:OnCreateFilteredList()
  local tResult = {}
  local nMaxCount = 500
  local bFits
  
  tResult["nCount"] = 0
  tResult["nTotalChars"] = 0
  
  tCensusDataFiltered = {}
  
  for k, v in pairs(tCensusData) do
    bFits = true
    
    if v.Faction == strFaction then
      bFits = (string.find(string.lower(k), tCharacterFilter["Name"]) ~= nil or tCharacterFilter["Name"] == "") and bFits
      bFits = (v.Race == tCharacterFilter["Race"] or tCharacterFilter["Race"] == "") and bFits
      bFits = (v.Class == tCharacterFilter["Class"] or tCharacterFilter["Class"] == "") and bFits
      bFits = (v.Path == tCharacterFilter["Path"] or tCharacterFilter["Path"] == "") and bFits
      bFits = (tonumber(v.Level) == tonumber(tCharacterFilter["Level"]) or tCharacterFilter["Level"] == "") and bFits
    
      if bFits and tResult["nCount"] ~= nMaxCount then 
        tCensusDataFiltered[k] = v 
        tResult["nCount"] = tResult["nCount"] + 1
      end
      tResult["nTotalChars"] = tResult["nTotalChars"] + 1
    end
    
    --if tResult["nCount"] == nMaxCount then break end
  end
  
  return tResult
end

function WildStarCensus:OnToggleSort( wndHandler, wndControl, eMouseButton )
  local strButtonText = self.wndSortButtonMarked:GetText()
  local strType = wndControl:GetText()
  --local bDesc = false
  
  if strButtonText ~= wndControl:GetText() then 
    if strButtonText ~= "" then self.wndMain:FindChild("Character_Sort_" .. strButtonText):Show(true, true) end
    self.wndSortButtonMarked:SetText(strType)
    self.wndSortButtonMarked:SetAnchorPoints(wndControl:GetAnchorPoints())
    self.wndSortButtonMarked:SetAnchorOffsets(wndControl:GetAnchorOffsets())
    self.wndSortButtonMarked:SetCheck(false)
    self.wndSortButtonMarked:Show(true, true)
    wndControl:Show(false, true)
    --if self.wndSortButtonMarked:IsEnabled() then 
  end
  
  self:SortCharacterList()
  --bDesc = self.wndSortButtonMarked:IsChecked()
  
  --self.wndCharactersContent:ArrangeChildrenVert(0, function(wndLeft, wndRight)
				--return self:SortName(wndLeft, wndRight, strType, bDesc)
			--end)

end

function WildStarCensus:SortCharacterList()
  local bDesc = false
  local strType = "Name"

  if self.wndSortButtonMarked:IsVisible() then
    bDesc = self.wndSortButtonMarked:IsChecked()
    strType = self.wndSortButtonMarked:GetText()
  end
  
  self.wndCharactersContent:ArrangeChildrenVert(0, function(wndLeft, wndRight)
		return self:SortName(wndLeft, wndRight, strType, bDesc)
    end)
end

function WildStarCensus:SortName(wndLeft, wndRight, strType, bDesc)
  local datLeft
  local datRight
  local strNameLeft = wndLeft:FindChild("Name"):GetText()
	local strNameRight = wndRight:FindChild("Name"):GetText()
  
  if (strType == "Name" or strType == "Location") then
    datLeft = wndLeft:FindChild(strType):GetText() or ""
    datRight = wndRight:FindChild(strType):GetText() or ""
  elseif strType == "Level" then
    datLeft = tonumber(wndLeft:FindChild(strType):GetText()) or 0
    datRight = tonumber(wndRight:FindChild(strType):GetText()) or 0
  else
    datLeft = wndLeft:FindChild(strType):GetData() or ""
    datRight = wndRight:FindChild(strType):GetData() or ""
  end
  if strType == "Name" then
    if bDesc then
      return datLeft > datRight
    else
      return datLeft < datRight
    end
  else
    if bDesc then
      return (datLeft > datRight) or (datLeft == datRight and strNameLeft < strNameRight)
    else
      return (datLeft < datRight) or (datLeft == datRight and strNameLeft < strNameRight)
    end
  end
end

function WildStarCensus:OnSetFilter( wndHandler, wndControl, strText )

  if string.len(strText) > 20 then
    strText = string.sub(strText, 1, 20)
    wndControl:SetText(strText)
  end
  tCharacterFilter["Name"] = string.lower(strText)
  Event_FireGenericEvent("EventGeneric_PopulateCharacterList")
end

function WildStarCensus:OnSetFilterIcon( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
  if bDoubleClick then
    local strValue
    
    if wndControl:GetName() == "Level" then
      strValue = wndControl:GetText()
    else
      strValue = wndControl:GetData()
    end

    if strValue == tCharacterFilter[wndControl:GetName()] then
      tCharacterFilter[wndControl:GetName()] = ""
    else
      tCharacterFilter[wndControl:GetName()] = strValue
    end
    Event_FireGenericEvent("EventGeneric_PopulateCharacterList") 
  end
end

function WildStarCensus:OnOpenCharacterOptions( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
  local wnd = wndControl:GetParent()
  local tCoordinates = {}
  
  tCoordinates[1] = 990
  tCoordinates[2] = self.wndCharactersContent:GetMouse().y + 84
  tCoordinates[3] = tCoordinates[1] + 224
  tCoordinates[4] = tCoordinates[2] + 124
  
  self.wndCharacterOptions:SetAnchorOffsets(tCoordinates[1], tCoordinates[2], tCoordinates[3], tCoordinates[4])
  if wndControl:IsChecked() then
    self.wndCharacterOptions:SetData(wnd)
    self.wndCharacterOptions:Show(true, true)
  else
    self.wndCharacterOptions:Show(false, true)
  end
end

function WildStarCensus:OnCloseCharacterOptions( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
  if self.wndCharacterOptions:GetData() ~= nil then
    self.wndCharacterOptions:GetData():FindChild("CharacterOptionsButton"):SetCheck(false)
    self.wndCharacterOptions:Show(false, true)
  end
end


function WildStarCensus:OnCharacterToFriends( wndHandler, wndControl, eMouseButton )
  strName = self.wndCharacterOptions:GetData():FindChild("Name"):GetText()
  FriendshipLib.AddByName(FriendshipLib.CharacterFriendshipType_Friend, strName, nil, "")
end

function WildStarCensus:OnCharacterToIgnore( wndHandler, wndControl, eMouseButton )
  strName = self.wndCharacterOptions:GetData():FindChild("Name"):GetText()
  FriendshipLib.AddByName(FriendshipLib.CharacterFriendshipType_Ignore, strName, nil, "")
end

function WildStarCensus:OnCharacterWhisper( wndHandler, wndControl, eMouseButton )
  strName = self.wndCharacterOptions:GetData():FindChild("Name"):GetText()
  Event_FireGenericEvent("GenericEvent_ChatLogWhisper", strName)
end

function WildStarCensus:OnFriendshipResult(strName, eResult)
  strName = self.wndCharacterOptions:GetData():FindChild("Name"):GetText()
  
  local strMessage = tFriendshipResult[eResult] or String_GetWeaselString(Apollo.GetString("Friends_UnknownResult"), eResult)
  ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, strMessage, "")
  
  if eResult == FriendshipLib.FriendshipResult_PlayerNotFound then
    tCensusData[strName] = nil
    ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, "Character \"" .. strName .. "\" deleted.", "")
    Event_FireGenericEvent("EventGeneric_PopulateCharacterList")
    self.wndCharacterOptions:SetData(nil)
    self.wndCharacterOptions:Show(false, true)
  end
end
-----------------------------------------------------------------------------------------------
-- WildStarCensus Timer-Settings
-----------------------------------------------------------------------------------------------
function WildStarCensus:OnTimerDropDown( wndHandler, wndControl, eMouseButton )
  local wndDropDown = self.wndMain:FindChild(wndControl:GetName() .. "List")
	wndDropDown:Show(not wndDropDown:IsShown(),true)
end

function WildStarCensus:OnTimerChosen( wndHandler, wndControl, eMouseButton )
  local name, value = wndControl:GetName():match("Button_(%a+)(%d+)")
  
  wndControl:GetParent():Show(false,true)

  tSettings[name .. "Text"] = wndControl:GetText()
	tSettings[name .. "Sec"] = value * 60
	
  if name == "CensusTimer" then
    if tSettings["CensusTimerSec"] == 0 then
      self.CensusTimer:Stop()
    else
      self.CensusTimer:Set(tSettings["CensusTimerSec"], true, "OnCensusTimer")
      self.CensusTimer:Start()
    end
  else
    self.TransferTimer:Set(tSettings["TransferTimerSec"], true, "OnTransferTimer")
  end
  self.wndMain:FindChild(name .. "SettingDropDown"):SetText(tSettings[name .. "Text"])
end

---------------------------------------------------------------------------------------------------
-- WildStarCensus Save and Restore
---------------------------------------------------------------------------------------------------
function WildStarCensus:OnSave(eLevel)
	local tSave = {}	
  
  if not tSettings["CensusLocked"] then tSettings["CensusRunning"] = false end
  
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Realm then
        return nil
	else
		if tCensusData ~= nil then tSave["tCensusData"] = tCensusData end
		if tMessages ~= nil then tSave["tMessages"] = tMessages end
    if tIgnoreList ~= nil then tSave["tIgnoreList"] = tIgnoreList end
		if tSettings ~= nil then tSave["tSettings"] = tSettings end
    if tLocationCollect ~= nil then tSave["tLocationCollect"] = tLocationCollect end
		return tSave
    end
end

function WildStarCensus:OnRestore(eLevel, tData)
	if eLevel == GameLib.CodeEnumAddonSaveLevel.Realm then
		if tData["tCensusData"] ~= nil then tCensusData = tData["tCensusData"] end
		if tData["tMessages"] ~= nil then tMessages = tData["tMessages"] end
    if tData["tIgnoreList"] ~= nil then tIgnoreList = tData["tIgnoreList"] end
		if tData["tSettings"] ~= nil then tSettings = tData["tSettings"] end
    if tData["tLocationCollect"] ~= nil then tLocationCollect = tData["tLocationCollect"] end
	end
end

---------------------------------------------------------------------------------------------------
-- General Functions
---------------------------------------------------------------------------------------------------
function General:GetStrServerTime()
	local strServerTime = ""
	local tServerTime = GameLib.GetServerTime()
	
	strServerTime = tServerTime["nYear"] .. "-" .. string.format("%02d", tServerTime["nMonth"]) .. "-" .. string.format("%02d", tServerTime["nDay"]) .. " " .. tServerTime["strFormattedTime"]
	
	return strServerTime
end

function General:GetTimeNumberToString(nTime)
  return os.date("%Y-%m-%d %H:%M:%S", nTime)
end

function General:GetTimeStringToNumber(strTime)
  local strPattern = "(%d+)-(%d+)-(%d+) (%d+):(%d+):(%d+)"
  
  year, month, day, hour, min, sec = strTime:match(strPattern)

  return os.time{year=year, month=month, day=day, hour=hour, min=min, sec=sec}
end

function General:GetDifferenceTime(strTime1, strTime2)
	local strPattern = "(%d+)-(%d+)-(%d+) (%d+):(%d+):(%d+)"
	local nTime1 = 0
	local nTime2 = 0
	local nMins = 0
	
	year, month, day, hour, min, sec = strTime1:match(strPattern)
	nTime1 = os.time({day=day, month=month, year=year, hour=hour, min=min, sec=0})
	year, month, day, hour, min, sec = strTime2:match(strPattern)
	nTime2 = os.time({day=day, month=month, year=year, hour=hour, min=min, sec=0})
	
	nMins = (nTime2-nTime1) / 60
	
	return nMins		
end

function General:GetClientLanguage()
	local strCancel = Apollo.GetString(1)

	if strCancel == "Abbrechen" then return "deDE"
  elseif strCancel == "Annuler" then return "frFR"
  else return "enUS"
	end
end

function General:ShrinkString(strText, nLength, nFactor)
  local strShrunk = ""
  local cChar
  local nCursor = 1

  if strText == nil or strText == "" then return end
  
  cChar = string.sub(strText, math.floor(string.len(strText) / nFactor), math.floor(string.len(strText) / nFactor))
  
  for i = 1, nLength do
    nCursor = (nCursor + string.byte(cChar)) % string.len(strText)
    strShrunk = strShrunk .. string.sub(strText, nCursor, nCursor)
    i = i + 1
  end
  
  return strShrunk
end

-----------------------------------------------------------------------------------------------
-- Ich spiel Lotto...denn ich brauch das Geld
-----------------------------------------------------------------------------------------------
function Lotto:GetLottoTable(max, draws)
  local tKeys = {}
  local tDraws = {}
  local index = 1
  local draw = 0
  
  if max >= draws then
    math.randomseed(os.time())
    
    while index <= draws do
      draw = math.random(max)
      
      if tKeys[draw] == nil then
        tKeys[draw] = ""
        index = index + 1
      end
    end
    
    for k, _ in pairs(tKeys) do
      table.insert(tDraws, k)
    end
    
    table.sort(tDraws)
  end
  return tDraws
end

-----------------------------------------------------------------------------------------------
-- Elf-Hash
-----------------------------------------------------------------------------------------------
function Hash:elfHash(toHash)
  HashDec = 0
  HashHex = ""
  HiBits = ""
  
  if toHash == nil then return end
  
  for pos = 1, string.len(toHash) do
    HashDec = self:BitLShift(HashDec,4) + string.byte(string.sub(toHash,pos,pos))
    
    HashHex = string.format("%08x", HashDec)
    
    HiBits = string.sub(HashHex,1,1) .. "0000000"
    HiBits = string.format("%08x", self:BitRShift(tonumber(HiBits,16),24))
    
    HashHex = self:HexXOR(HashHex, HiBits, 8)
    
	if pos < string.len(toHash) then
    	HashHex = string.format("%08s", string.sub(HashHex, 2))    
    	HashDec = tonumber(HashHex,16)
	end

  end
  
  return HashHex
end

function Hash:HexXOR(hexA, hexB, len)
  local binXOR = ""
  local binA = ""
  local binB = ""
  local digA = 0
  local digB = 0
  local digXOR = 0
  
  binA = self:HexToBin(hexA)
  binB = self:HexToBin(hexB)
  
  binA = string.format("%0" .. len*4 .. "s", binA)
  binB = string.format("%0" .. len*4 .. "s", binB)
  
  for i = 1, len*4 do
    digA = string.sub(binA,i,i)
    digB = string.sub(binB,i,i)
    
    if digA == digB then
      digXOR = 0
    else
      digXOR = 1
    end
    
    binXOR = binXOR .. digXOR
  end

  return string.format("%0" .. len .. "s", self:BinToHex(binXOR))
end
function Hash:DecToBin(dec)
  return self:HexToBin(string.format("%x", dec))
end

function Hash:HexToBin(hex)
  local bin = ""
   convert = {["0"] = "0000",["1"] ="0001",["2"] ="0010",["3"] ="0011",
                ["4"] ="0100",["5"] ="0101",["6"] ="0110",["7"] ="0111",
                ["8"] ="1000",["9"] ="1001",["a"] ="1010",["b"] ="1011",
                ["c"] ="1100",["d"] ="1101",["e"] ="1110",["f"] ="1111",
                ["A"] ="1010",["B"] ="1011",["C"] ="1100",["D"] ="1101",
                ["E"] ="1110",["F"] ="1111"}
              
  for i = 1, string.len(hex) do
    if convert[string.sub(hex,i,i)] == nil then
      break
    else
      bin = bin .. convert[string.sub(hex,i,i)]
    end
  end
  return bin
end

function Hash:BinToHex(bin)
  return string.format("%x", tonumber(bin,2))
end

function Hash:BitLShift(dec, digits)
  bin = ""
  
  bin = self:DecToBin(dec)
  
  for i = 1, digits do
    bin = bin .. "0"
  end
  return tonumber(bin,2)
end

function Hash:BitRShift(dec, digits)
  bin = ""
  lenBin = 0
  
  bin = self:DecToBin(dec)
  lenBin = string.len(bin)
  
  if lenBin <= digits then 
    bin = 0
  else
    bin = string.sub(bin,1,string.len(bin)-digits)
  end

  return tonumber(bin,2)
end

---------------------------------------------------------------------------------------------------
-- WildStarCensusForm Functions
---------------------------------------------------------------------------------------------------

function WildStarCensus:OnZoneTimer()
  local tZoneMap = GameLib.GetCurrentZoneMap()
  if tLocationCollect[GameLib.GetCurrentZoneId()] == nil then
    tLocationCollect[GameLib.GetCurrentZoneId()] = tZoneMap
  end
end

--ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug, "Test", "")

-----------------------------------------------------------------------------------------------
-- WildStarCensus Instance
-----------------------------------------------------------------------------------------------
local WildStarCensusInst = WildStarCensus:new()
WildStarCensusInst:Init()
